function cstr_diff_plot(run,t,y,i)

%no is number of runs (1:no) OR vector of run indices to plot

if(nargin < 4), no = 5; end
grey = 0.4*[1 1 1];
green = [0.1 0.5 0.2];
nz =14;

set(gcf,'position',[120   136   664*2   781]);
clf

    runs = 1;
    anno = 1;


   
    subplot(321)
    hold on;
    plot(t,y(:,(3+(i-1)*nz)),'b');
    plot(run(i).time,run(i).pcod,'o-','color',[0 0.5 1]);
    hold off;
    
    ylabel('pCOD (mg/l)');
    title(sprintf('TEMP %g    MIXING %g    O2 %g',run(i).temp,run(i).mixing,run(i).o2));
    if anno
        pcod = interp1(t,y(:,(3+(i-1)*nz)),run(i).time);
        pcod_err = ((pcod-run(i).pcod)./run(i).pcod)*100;
        
        labels=cellstr(num2str(pcod_err, '%2.0f%%'));
        text(run(i).time, run(i).pcod, labels, 'VerticalAlignment', 'bottom', 'HorizontalAlignment', 'left', 'color',grey);
    end
    yl = ylim;
    ylim([0 yl(2)]);
    xlim([0 t(end)]);
    
    subplot(323)
    hold on;
    if anno
        plot(t,[y(:,(4)) y(:,(5)) y(:,(6))],':','color',grey);
    end
    plot(t,y(:,(7+(i-1)*nz)),'color',green);
    plot(run(i).time,run(i).scod-run(i).vfa,'o-','color',[0.1 0.7 0]);
    hold off;
    ylabel('sCOD (mg/l)');
    if anno
        scod = interp1(t,y(:,(7+(i-1)*nz)),run(i).time);
        scod_err = ((scod-(run(i).scod-run(i).vfa))./(run(i).scod-run(i).vfa))*100;
        labels=cellstr(num2str(scod_err, '%2.0f%%'));
        text(run(i).time,run(i).scod-run(i).vfa, labels, 'VerticalAlignment', 'bottom', 'HorizontalAlignment', 'left', 'color',grey);
    end
    yl = ylim; ylim([0 yl(2)]);
    xlim([0 t(end)]);
    
    subplot(325)
    hold on;
    plot(t,[y(:,8+(i-1)*nz)],'color',[0.7 0.1 0]);
    plot(run(i).time,[run(i).ac],'o-r');
    hold off;
    ylabel('AACOD (mg/l)');
    xlabel('Time (s)');
    if anno
        ac = interp1(t,[y(:,8+(i-1)*nz)],run(i).time);
        ac_err = ((ac-run(i).ac)./run(i).ac)*100;
        labels=cellstr(num2str(ac_err, '%2.0f%%'));
        text(run(i).time, run(i).ac, labels, 'VerticalAlignment', 'bottom', 'HorizontalAlignment', 'left', 'color',grey);
    end
    yl = ylim; ylim([0 yl(2)]);
    xlim([0 t(end)]);
    
    subplot(322)
    hold on;
    plot(t,[y(:,10+(i-1)*nz)]);
    if isnan(run(i).O2gasfrac(end)) == 0
        plot(run(i).time,[run(i).O2gasmass*1000],'o-r');
        if anno
            o2 = interp1(t,[y(:,10+(i-1)*nz)],run(i).time);
            o2_err = ((o2-run(i).O2gasmass*1000)./(run(i).O2gasmass*1000))*100;
            labels=cellstr(num2str(o2_err, '%2.0f%%'));
            text(run(i).time, run(i).O2gasmass*1000, labels, 'VerticalAlignment', 'bottom', 'HorizontalAlignment', 'left', 'color',grey);
        end
    end
    ylabel('O2 (g)');
    title(sprintf('TEMP %g    MIXING %g    O2 %g',run(i).temp,run(i).mixing,run(i).o2));
    yl = ylim;
    %ylim([0 yl(2)]);
    ylim('auto');
    xlim([0 t(end)]);
    
    subplot(324)
    hold on;
    plot(t,[y(:,14+(i-1)*nz)],'color',green);
    plot(run(i).time,run(i).vfa-run(i).ac,'o-','color',[0.1 0.7 0]);
    hold off;
    ylabel('other VFA cod');
    if anno
        vfa = interp1(t,y(:,14+(i-1)*nz),run(i).time);
        vfa_err = ((vfa-(run(i).vfa-run(i).ac))./(run(i).vfa-run(i).ac))*100;
        labels=cellstr(num2str(vfa_err, '%2.0f%%'));
        text(run(i).time, run(i).vfa-run(i).ac, labels, 'VerticalAlignment', 'bottom', 'HorizontalAlignment', 'left', 'color',grey);
    end
    yl = ylim;
    ylim([0 yl(2)]);
    xlim([0 t(end)]);
    
    subplot(326)
    hold on;
    plot(t,[y(:,11+(i-1)*nz)],'color',[0.7 0.1 0]);
    plot(run(i).time,run(i).don,'o-r');
    hold off;
    ylabel('DON');
    xlabel('Time (s)');
    if anno
        don = interp1(t,y(:,11+(i-1)*nz),run(i).time);
        don_err = ((don-run(i).don)./run(i).don)*100;
        labels=cellstr(num2str(don_err, '%2.0f%%'));
        text(run(i).time, run(i).don, labels, 'VerticalAlignment', 'bottom', 'HorizontalAlignment', 'left', 'color',grey);
    end
    yl = ylim;
    ylim([0 yl(2)]);
    xlim([0 t(end)]);
    
    