function j = cstr_optim(theta, mode, gf, temp, run, run_lb, fitindexes, fitxdata, fitydata, weighting, z0indexes, z0, minidx, rangeidx)

%Separate params and initial condition fitting
params = theta(1:end-1);
z0e = theta(end);

% ODE timespan
tspan = [0 120 300 600 1200 3600];
maxTime = 7;

zinit = z0;
zinit(z0indexes) = zinit(z0indexes)*z0e; %pCODfast
zinit(z0indexes+1) = zinit(z0indexes+1)*(1-z0e); %pCODslow

numrun = length(run);
mixing = [run.mixing]';
switch(mode)
    case 'data'
        temp = [run_lb(1:numrun).temp];
end

ode = @(t,z) cstr_calc(t, z, params, mode, gf, temp, mixing);
% Integrate
odeopts = odeset('OutputFcn',@(t,y,flag) odeMaxTime(t,y,flag,maxTime));
%[~, zr] = ode45(ode,tspan,zinit,odeopts);
[~, zr] = ode15s(ode,tspan,zinit,odeopts);
if(size(zr,1) ~= length(tspan))
    j = 1e6;
else
    
    zfit = zr(:,fitindexes);
    zfit = ((zfit-minidx)./rangeidx)*100;
    
    fitydata = ((fitydata-minidx)./rangeidx)*100;
    
    %j = norm(sqrt(sum((zfit-fitydata).^2)));
    j = norm((zfit-fitydata).*weighting);
end

end



function status = odeMaxTime(~,~,flag,maxTime)
%Callback to stop ODE if max time exceeded
persistent tt
status=0; %continue
switch(flag)
    case 'init'
        tt = tic;
    case ''
        if(toc(tt) > maxTime)
            fprintf(2,'ODE Integrator Max Time [%gs] Exceeded\n',maxTime);
            status = 1;
        end
end
end