function cstr_vec_plot_pp(run,t,y,no)

%no is number of runs (1:no) OR vector of run indices to plot

% define colours
blue = [0 0.5 1];
bluevdark = [0.152941176470588         0.227450980392157         0.372549019607843];
bluedark = [ 0.392156862745098         0.474509803921569         0.635294117647059];
purpledark =  [0.4                         0                       0.4];
purple = [1     0     1];
lightgreen = [0.1 0.7 0];
green=[0.105882352941176 0.309803921568627 0.207843137254902];
lightred = [1 0 0];
red = [0.6 0 0]; %[0.7 0.1 0];
orange = [0.81 0.33 0];
lightorange = [1 0.694117647058824 0.392156862745098];
grey = 0.4*[1 1 1];


if(nargin < 4), no = 5; end
nz =14;

set(gcf,'position',[120   136   664*2   781]);
clf

% if(length(no) > 1)
%     runs = no;
%     no = length(no);
% else
%     runs = 1:no;
% end
    anno = 0;
if(length(no) > 1)
    runs = 1:length(no);
else
    runs = 1;
    anno = 0;
end
    j=1;
    
for k = runs(1):runs(end)
    
    if length(no) > 1
        i = no(k);
        j=i;
    else
        i=1;
        j = no(k);
    end
     
    % plot pCOD
    subplot(321)
    hold on;
    plot(t,y(:,(3+(i-1)*nz)),'b'); 
    plot(run(j).time,run(j).pcod,'o-','color',[0 0.5 1]);
    hold off;
    yl = ylim; 
    ylim([0 yl(2)]); 
    xlim([0 t(end)]);
     
    ylabel('pCOD (mg/l)');
    title(sprintf('Temperature %g^{\\circ}C, Mixing %g RPM, O_2 %g',run(j).temp,run(j).mixing,run(j).o2));
    if anno
        pcod = interp1(t,y(:,(3+(i-1)*nz)),run(j).time);
        pcod_err = ((pcod-run(j).pcod)./run(j).pcod)*100;
        
        labels=cellstr(num2str(pcod_err, '%2.0f%%'));
        text(run(j).time, run(j).pcod, labels, 'VerticalAlignment', 'bottom', 'HorizontalAlignment', 'left', 'color',grey);
    end

    % plot sCOD
    subplot(323)
    hold on;
%     if anno
%         plot(t,[y(:,(4)) y(:,(5)) y(:,(6))],':','color',grey);
%     end
    plot(t,y(:,(7+(i-1)*nz)),'color',green); 
    plot(run(j).time,run(j).scod-run(j).vfa,'o-','color',lightgreen);
    hold off; 
    yl = ylim; 
    ylim([0 yl(2)]); 
    xlim([0 t(end)]);
    
    ylabel('sCOD (mg/l)');
    if anno
        scod = interp1(t,y(:,(7+(i-1)*nz)),run(j).time);
        scod_err = ((scod-(run(j).scod-run(j).vfa))./(run(j).scod-run(j).vfa))*100;
        labels=cellstr(num2str(scod_err, '%2.0f%%'));
        text(run(j).time,run(j).scod-run(j).vfa, labels, 'VerticalAlignment', 'bottom', 'HorizontalAlignment', 'left', 'color',grey);    
    end
    
    % plot AACOD
    subplot(325)
    hold on;
    plot(t,[y(:,8+(i-1)*nz)],'color',red);
    plot(run(j).time,[run(j).ac],'o-', 'color',lightred); 
    hold off;
    yl = ylim; 
    ylim([0 yl(2)]); 
    xlim([0 t(end)]);
    
    ylabel('AACOD (mg/l)'); 
    xlabel('Time (s)');
    if anno
        ac = interp1(t,[y(:,8+(i-1)*nz)],run(j).time);
        ac_err = ((ac-run(j).ac)./run(j).ac)*100;
        labels=cellstr(num2str(ac_err, '%2.0f%%'));
        text(run(j).time, run(j).ac, labels, 'VerticalAlignment', 'bottom', 'HorizontalAlignment', 'left', 'color',grey);    
    end  


    % plot O2
    subplot(322)
    hold on;
    plot(t,[y(:,10+(i-1)*nz)],'color',bluevdark);
    if isnan(run(j).O2gasfrac(end)) == 0
        plot(run(j).time,[run(j).O2gasmass*1000],'o-','color',bluedark);      
        if anno
            o2 = interp1(t,[y(:,10+(i-1)*nz)],run(j).time);
            o2_err = ((o2-run(j).O2gasmass*1000)./(run(j).O2gasmass*1000))*100;
            labels=cellstr(num2str(o2_err, '%2.0f%%'));
            text(run(j).time, run(j).O2gasmass*1000, labels, 'VerticalAlignment', 'bottom', 'HorizontalAlignment', 'left', 'color',grey);    
        end  
    end    
    hold off;
    yl = ylim;      
    ylim([0 yl(2)]);
    xlim([0 t(end)]);
    
    ylabel('O_2 (g)'); 
    title(sprintf('Temperature %g^{\\circ}C, Mixing %g RPM, O_2 %g',run(j).temp,run(j).mixing,run(j).o2));

    % plot otherVFA COD
    subplot(324)
    hold on;
    plot(t,[y(:,14+(i-1)*nz)],'color',orange); 
    plot(run(j).time,run(j).vfa-run(j).ac,'o-','color',lightorange); 
    yl = ylim; 
    ylim([0 yl(2)]); 
    xlim([0 t(end)]);
    hold off;
    
    ylabel('other VFA COD (mg/l)');
    if anno
        vfa = interp1(t,y(:,14+(i-1)*nz),run(j).time);
        vfa_err = ((vfa-(run(j).vfa-run(j).ac))./(run(j).vfa-run(j).ac))*100;
        labels=cellstr(num2str(vfa_err, '%2.0f%%'));
        text(run(j).time, run(j).vfa-run(j).ac, labels, 'VerticalAlignment', 'bottom', 'HorizontalAlignment', 'left', 'color',grey);    
    end    

    % plot DON
    subplot(326)
    hold on;
    plot(t,[y(:,11+(i-1)*nz)],'color',purpledark);
   % plot(run(j).time,run(j).don,'o-','color',purple); 
    yl = ylim; 
    ylim([0 yl(2)]); 
    xlim([0 t(end)]);
    hold off;
    ylabel('DON (mg/l)');
    xlabel('Time (s)');
    if anno
        don = interp1(t,y(:,11+(i-1)*nz),run(j).time);
        don_err = ((don-run(j).don)./run(j).don)*100;
        labels=cellstr(num2str(don_err, '%2.0f%%'));
        text(run(j).time, run(j).don, labels, 'VerticalAlignment', 'bottom', 'HorizontalAlignment', 'left', 'color',grey);    
    end    
  
end

%  figure(2);
% for k = runs(1):runs(end)
%     i = no(k);    
%     hold on; 
% %     if run(i).CO2gasmass(end) > 0
% %         plot(run(i).time,[run(i).CO2gasmass*1000],'o-r');
% % 
% %     end
%         plot(t,[y(:,9+(i-1)*nz)],'color',[0.7 0.1 0]); 
%         ylabel('CO2');
%         xlabel('Time (s)');
%     hold off
% end

% print(gcf,'-dpng',filename); 