from __future__ import division
import asim
import scipy as sp
import matplotlib.pyplot as plt
import time

"""
# Create reaction object
oxidation = asim.reaction()

# Add a reaction, in this case A -> B
oxidation.add('A -> B', [7.2e10], 5e4, 0.239, 1000)
oxidation.add('B -> C', [7.2e10], 5e4, 0.239, 1000)
# Set initial conditions
oxidation.feedConc = {"A": 1.0, "B": 0, "C": 0}
oxidation.feedTemp = 395

#pfr = asim.plugflow(oxidation)
#pfr.initial_conditions = {"A": 1.0, "B": 0, "C": 0}
#pfr.initial_conditions = {"A": 1.0, "B": 0, "C": 0}
#pfr_output = pfr.output()


# Add a CSTR reactor
cstr1 = asim.cstr(oxidation)
# Specifiy reactor features, volume etc
cstr1.volume = 100
cstr1.flowrate = 100
# Set initial conditions
cstr1.initial_conditions = {"A": 0.0, "B": 0, "C": 0}
cstr1.initial_temp = 324.475
# Get the reactor output, this can be simulated or fed as an input to another reactor
cstr1_output = cstr1.output()


# Configure simulation end time
tf = 1000
# Perform simulation
t_elapsed = time.time()

x = asim.sim(cstr1_output,tf)

elapsed = time.time() - t_elapsed
print(elapsed)

# Plot results
interval = tf/len(x)
y = sp.arange(0,tf,interval)

conc1 = x[:,0:3]
conc2 = x[:,4:7]
temp = x[:,-1]

# Plot temperature
fig1 = plt.figure()
ax1 = fig1.add_subplot(111)
ax1.set_title("Temperature of rectants vs time")
ax1.set_xlabel("Time (s)")
ax1.set_ylabel("Temperature (K)")
ax1.plot(y,temp)

# Plot concentration
fig2 = plt.figure()
ax2 = fig2.add_subplot(111)
ax2.set_title("Concentration of reaction compounds vs time")
ax2.set_xlabel("Time (s)")
ax2.set_ylabel("Concentration (mol/L)")
ax2.plot(y,conc1)
ax2.legend(('A', 'B'), 'upper right', shadow=True)

fig3 = plt.figure()
ax3 = fig3.add_subplot(111)
ax3.plot(y,conc2)
plt.show()


"""
# Create reaction object
oxidation = asim.reaction()

# Add a reaction, in this case A -> B
oxidation.add('A -> B', [7.8e10], 5e4, 0.239, 1000)
oxidation.add('B -> C', [7.2e10], 5e4, 0.239, 1000)
oxidation.add('C -> B', [6.5e10], 5e4, 0.239, 1000)
oxidation.add('C -> D', [7.2e10], 5e4, 0.239, 1000)
# Set initial conditions
oxidation.feedConc = {"A": 1.0, "B": 0, "C": 0, "D": 0}
oxidation.feedTemp = 390

pfr = asim.plugflow(oxidation)
pfr_output = pfr.output()

# Configure simulation end time
tf = 2500
# Perform simulation
x = asim.sim(pfr_output,tf)


# Add a CSTR reactor
cstr1 = asim.cstr(oxidation)
# Specifiy reactor features, volume etc
cstr1.volume = 0.0393
cstr1.flowrate = 0.0001
# Set initial conditions
cstr1.initial_conditions = {"A": 0.0, "B": 0, "C": 0, "D": 0}
cstr1.initial_temp = 324.475
# Get the reactor output, this can be simulated or fed as an input to another reactor
cstr1_output = cstr1.output()


pfr = asim.plugflow(cstr1_output)

pfr.initial_conditions = {"A": 1.0, "B": 0, "C": 0}
pfr.initial_conditions = {"A": 1.0, "B": 0, "C": 0}
pfr_output = pfr.output()

# Add a second CSTR reactor
cstr2 = asim.cstr(cstr1_output)
# Specifiy reactor features, volume etc
cstr2.volume = 0.0393
cstr2.flowrate = 0.0001
# Set initial conditions
cstr2.initial_conditions = {"A": 0.0, "B": 0, "C": 0, "D": 0}
cstr2.initial_temp = 424.475
# Get the reactor output, this can be simulated or fed as an input to another reactor
cstr2_output = cstr2.output()

# Configure simulation end time
tf = 5000
# Perform simulation
x = asim.sim(cstr2_output,tf)
"""
"""
# Plot results
interval = tf/len(x)
y = sp.arange(0,tf,interval)
conc1 = x[:,0:4]
conc2 = x[:,-5:-1]
#conc = x[:,0:-1]
temp = x[:,-1]

# Plot temperature
fig1 = plt.figure()
ax1 = fig1.add_subplot(111)
ax1.set_title("Temperature of rectants vs time")
ax1.set_xlabel("Time (s)")
ax1.set_ylabel("Temperature (K)")
ax1.plot(y,temp)


# Plot concentration
fig2 = plt.figure()
ax2 = fig2.add_subplot(111)
ax2.set_title("Concentration of reaction compounds vs time")
ax2.set_xlabel("Time (s)")
ax2.set_ylabel("Concentration (mol/L)")
ax2.plot(y,conc2)
ax2.legend(('A', 'B', 'C', 'D'), 'upper right', shadow=True)

plt.show()



"""


ax1 = plt.subplot(111)
ax1.set_xlabel("Time (s)")
ax1.set_ylabel("Temperature (K)")
ax1.plot(y,temp,'y')

ax1.legend(('Temp'),'center right')

ax2 = plt.twinx()

ax2.plot(y,conc)
ax2.set_title('Concentration of reaction compounds vs time')
ax2.set_xlabel('Time (s)')
ax2.set_ylabel('Concentration (mol/L)')

ax2.legend(('A', 'B', 'C'), 'upper right', shadow=True)

plt.show()
"""